/*
 * Copyright (c) 2015 - 2017, Dries007 & Double Door Development
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * + Redistributions via the Curse or CurseForge platform are not allowed without
 *   written prior approval.
 *
 * + Redistributions of source code must retain the above copyright notice, this
 *   list of conditions and the following disclaimer.
 *
 * + Redistributions in binary form must reproduce the above copyright notice,
 *   this list of conditions and the following disclaimer in the documentation
 *   and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */

package net.doubledoordev.mtrm.client.parts;

import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.FontRenderer;
import net.minecraft.client.gui.GuiButton;
import net.minecraft.client.renderer.GlStateManager;

import static net.doubledoordev.mtrm.client.ClientHelper.BTN_COLORS;
import static net.doubledoordev.mtrm.client.ClientHelper.TEXT_COLORS;
import static net.minecraft.client.renderer.GlStateManager.DestFactor.ONE_MINUS_SRC_ALPHA;
import static net.minecraft.client.renderer.GlStateManager.DestFactor.ZERO;
import static net.minecraft.client.renderer.GlStateManager.SourceFactor.ONE;
import static net.minecraft.client.renderer.GlStateManager.SourceFactor.SRC_ALPHA;

/**
 * @author Dries007
 */
public class GuiIconButton extends GuiButton
{
    private final Icon icon;

    public GuiIconButton(int buttonId, int x, int y, int widthIn, int heightIn, String buttonText, Icon icon)
    {
        super(buttonId, x, y, widthIn, heightIn, buttonText);
        this.icon = icon;
    }

    public GuiIconButton(int buttonId, int x, int y, String buttonText, Icon icon)
    {
        this(buttonId, x, y, 20, 20, buttonText, icon);
    }

    @Override
    public void func_146112_a(Minecraft mc, int mouseX, int mouseY)
    {
        if (!field_146125_m)
        {
            return;
        }

        field_146123_n = mouseX >= field_146128_h && mouseY >= field_146129_i && mouseX < field_146128_h + field_146120_f && mouseY < field_146129_i + field_146121_g;
        // 0 = disabled, 1 = normal, 2 = hover
        int state = func_146114_a(field_146123_n);

        GlStateManager.func_179131_c(1.0F, 1.0F, 1.0F, 1.0F);
        GlStateManager.func_179147_l();
        GlStateManager.func_187428_a(SRC_ALPHA, ONE_MINUS_SRC_ALPHA, ONE, ZERO);
        GlStateManager.func_187401_a(SRC_ALPHA, ONE_MINUS_SRC_ALPHA);

        int right = field_146128_h + field_146120_f;
        int bottom = field_146129_i + field_146121_g;

        func_73734_a(field_146128_h, field_146129_i, right, bottom, 0xFF000000);

        func_73734_a(field_146128_h + 1, field_146129_i + 1, right - 2, bottom - 3, 0xA0000000 | BTN_COLORS[state]);

        func_73730_a(field_146128_h + 1, right - 2, field_146129_i + 1, 0x80555555 | BTN_COLORS[state]);
        func_73728_b(field_146128_h + 1, field_146129_i + 1, bottom - 1, 0x80555555 | BTN_COLORS[state]);
        func_73734_a(field_146128_h + 1, bottom - 3, right - 1, bottom - 1, 0x80000000 | BTN_COLORS[state]);
        func_73728_b(right - 2, field_146129_i + 1, bottom - 3, 0x80000000 | BTN_COLORS[state]);

        GlStateManager.func_179131_c(1.0F, 1.0F, 1.0F, 1.0F);
        GlStateManager.func_179147_l();
        GlStateManager.func_187428_a(SRC_ALPHA, ONE_MINUS_SRC_ALPHA, ONE, ZERO);
        GlStateManager.func_187401_a(SRC_ALPHA, ONE_MINUS_SRC_ALPHA);
        mc.func_110434_K().func_110577_a(Icon.TEXTURE);
        int iconId = icon.hasAlt() && !field_146124_l ? icon.getAlt().ordinal() : icon.ordinal();
        func_73729_b(field_146128_h - 8 + field_146120_f / 2, field_146129_i - 8 + field_146121_g / 2, 16 * (iconId % 16), 16 * (iconId / 16), 16, 16);

        if (field_146123_n)
        {
            FontRenderer fr = mc.field_71466_p;
            int centerX = field_146120_f / 2;
            int centerY = field_146121_g / 2;
            int width = fr.func_78256_a(field_146126_j) / 2 + 2;
            int height = fr.field_78288_b / 2 + 2;
            func_73734_a(field_146128_h + centerX - width, field_146129_i + centerY - height, field_146128_h + centerX + width, field_146129_i + centerY + height, 0xA0000000);
            func_73732_a(fr, field_146126_j, field_146128_h + this.field_146120_f / 2, field_146129_i + (this.field_146121_g - 8) / 2, TEXT_COLORS[state]);
        }
    }
}
